from django.db import transaction
from rest_framework import serializers

from greg.models import Identity, Person


class GuestRegisterSerializer(serializers.ModelSerializer):
    email = serializers.CharField(required=True)

    def create(self, validated_data):
        # TODO: this serializer is untested
        email = validated_data.pop("email")
        with transaction.atomic():
            person = super().create(**validated_data)
            Identity.objects.create(
                person=person,
                type=Identity.IdentityType.PRIVATE_EMAIL,
                value=email,
            )
        return person

    class Meta:
        model = Person
        fields = ("id", "first_name", "last_name", "email")
        read_only_fields = ("id",)
        extra_kwargs = {
            "first_name": {"required": True},
            "last_name": {"required": True},
        }
